Code

[PATCH] Expose object ID computation functions.
[git.git] / git-resolve-script
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 #
5 # Resolve two trees.
6 #
7 . git-sh-setup-script || die "Not a git archive"
9 head=$(git-rev-parse --revs-only "$1")
10 merge=$(git-rev-parse --revs-only "$2")
11 merge_repo="$3"
13 dropheads() {
14         rm -f -- "$GIT_DIR/MERGE_HEAD" \
15                 "$GIT_DIR/LAST_MERGE" || exit 1
16 }
18 #
19 # The remote name is just used for the message,
20 # but we do want it.
21 #
22 if [ -z "$head" -o -z "$merge" -o -z "$merge_repo" ]; then
23         die "git-resolve-script <head> <remote> <merge-repo-name>"
24 fi
26 dropheads
27 echo $head > "$GIT_DIR"/ORIG_HEAD
28 echo $merge > "$GIT_DIR"/LAST_MERGE
30 common=$(git-merge-base $head $merge)
31 if [ -z "$common" ]; then
32         die "Unable to find common commit between" $merge $head
33 fi
35 if [ "$common" == "$merge" ]; then
36         echo "Already up-to-date. Yeeah!"
37         dropheads
38         exit 0
39 fi
40 if [ "$common" == "$head" ]; then
41         echo "Updating from $head to $merge."
42         git-read-tree -u -m $head $merge || exit 1
43         echo $merge > "$GIT_DIR"/HEAD
44         git-diff-tree -p $head $merge | git-apply --stat
45         dropheads
46         exit 0
47 fi
48 echo "Trying to merge $merge into $head"
49 git-read-tree -u -m $common $head $merge || exit 1
50 merge_msg="Merge $merge_repo"
51 result_tree=$(git-write-tree  2> /dev/null)
52 if [ $? -ne 0 ]; then
53         echo "Simple merge failed, trying Automatic merge"
54         git-merge-cache -o git-merge-one-file-script -a
55         if [ $? -ne 0 ]; then
56                 echo $merge > "$GIT_DIR"/MERGE_HEAD
57                 die "Automatic merge failed, fix up by hand"
58         fi
59         result_tree=$(git-write-tree) || exit 1
60 fi
61 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree -p $head -p $merge)
62 echo "Committed merge $result_commit"
63 echo $result_commit > "$GIT_DIR"/HEAD
64 git-diff-tree -p $head $result_commit | git-apply --stat
65 dropheads